/*
 * cmdu_ackq.h
 * CMDU pending response and ack queue management
 *
 * Copyright (C) 2020 IOPSYS Software Solutions AB. All rights reserved.
 *
 * Author: anjan.chanda@iopsys.eu
 *
 * See LICENSE file for license related information.
 *
 */

#ifndef EVENTLOG_H
#define EVENTLOG_H

//#include <easy/easy.h>
//#include <wifi.h>

/* struct holds a STA events */
struct sta_eventlog_entry {
	char ifname[16];
	uint8_t mac[6];
	uint8_t bssid[6];
	struct wifi_sta sta;
	atimer_t t;
	struct sta_eventlog *sv;		// Pointer to hold sta eventlog queue address
	struct hlist_node hlist;
};

/* queue for STA events */
struct sta_eventlog {
	pthread_mutex_t evlock;
	int active_sta_cnt;
	struct hlist_head start;
};

extern int sta_eventlog_init(void *sta_log);
extern struct sta_eventlog_entry *sta_eventlog_lookup(void *sta_log, uint8_t *mac);
extern int sta_eventlog_enqueue(void *sta_log, const char *ifname, uint8_t *mac);
extern int sta_eventlog_dequeue(void *sta_log, uint8_t *mac);

#endif /* EVENTLOG_H */
