#ifndef DEAGENT_TLV_H
#define DEAGENT_TLV_H

int deagent_gen_aladdr(struct deagent_private *priv, struct cmdu_buff *cmdu);
int deagent_gen_searched_role(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t role);
int deagent_gen_autoconfig_band(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t band);
int deagent_gen_supported_service(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t service);
int deagent_gen_searched_service(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t service);
int deagent_gen_map_profile(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t profile);

int deagent_gen_i1905_tlvs(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_ap_oper_bss(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_assoc_client(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_ap_cap(struct wifi_network_device *dev, struct cmdu_buff *cmdu);
int deagent_gen_ap_radio_basic_cap(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index);
int deagent_gen_ap_ht_cap(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index);
int deagent_gen_ap_vht_cap(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index);
int deagent_gen_ap_he_cap(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index);
int deagent_gen_channel_scan_capability(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_cac_cap(struct wifi_network_device *dev, struct cmdu_buff *cmdu);
int deagent_gen_profile2_ap_cap(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_metric_collection_int(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_radio_metrics(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index);
int deagent_gen_ap_metrics(struct wifi_network_device *own,
		struct cmdu_buff *cmdu, int radio_index, int bss_index);
int deagent_gen_ap_ext_metrics(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index, int bss_index);
int deagent_gen_assoc_sta_traffic_stats(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index,
		int bss_index, int sta_index);
int deagent_gen_assoc_sta_link_metrics(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index,
		int bss_index, int sta_index);
int deagent_gen_assoc_sta_ext_link_metric(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index,
		int bss_index, int sta_index);
int deagent_gen_bsta_radio_cap(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index);
int deagent_gen_oper_channel_report(struct wifi_network_device *dev,
		struct cmdu_buff *cmud, int radio_index);
int deagent_gen_timestamp(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);
int deagent_gen_channel_scan_result(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu, int radio_index,
		int opclass_index, int channel_index);
int deagent_gen_client_assoc_event(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t *sta_mac,
		const char *event, uint8_t *bssid);
int deagent_gen_sta_mac(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t *sta);
int deagent_gen_reason_code(struct deagent_private *priv,
		struct cmdu_buff *cmdu, int reason_code);
int deagent_gen_disassoc_stats(struct deagent_private *priv, struct cmdu_buff *cmdu,
		uint8_t *sta, struct wifi_disassoc_events *disassoc_ev);
int deagent_gen_client_info(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t *sta, uint8_t *bssid);
int deagent_gen_client_cap_report(struct deagent_private *priv,
		struct cmdu_buff *cmdu, uint8_t result,
		struct wifi_assoc_frame *assoc_frame);
int deagent_gen_error_code(struct deagent_private *priv, struct cmdu_buff *cmdu,
		uint8_t reason, uint8_t *sta);
int deagent_gen_vendor_specific(struct wifi_network_device *dev,
		struct cmdu_buff *cmdu);

#endif /* DEAGENT_TLV_H */

