


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#include <libubox/list.h>

#include <easy/easy.h>

#include "wfa_delm.h"
#include "common.h"

#ifndef BIT
#define BIT(n)	(1 << (n))
#endif

static struct wifi_opclass_entry wifi_opclass_global[] = {
	{ 81, BAND_2, BW20, EXTCH_NONE, {20, 13, {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13}}},
	{ 82, BAND_2, BW20, EXTCH_NONE, {20, 1, {14}}},
	{ 83, BAND_2, BW40, EXTCH_ABOVE, {20, 9, {1, 2, 3, 4, 5, 6, 7, 8, 9}}},
	{ 84, BAND_2, BW40, EXTCH_BELOW, {20, 9, {5, 6, 7, 8, 9, 10, 11, 12, 13}}},

	{ 115, BAND_5, BW20, EXTCH_NONE, {23, 4, {36, 40, 44, 48}}},
	{ 116, BAND_5, BW40, EXTCH_ABOVE, {23, 2, {36, 44}}},
	{ 117, BAND_5, BW40, EXTCH_BELOW, {23, 2, {40, 48}}},
	{ 118, BAND_5, BW20, EXTCH_NONE, {23, 4, {52, 56, 60, 64}}},
	{ 119, BAND_5, BW40, EXTCH_ABOVE, {23, 2, {52, 60}}},
	{ 120, BAND_5, BW40, EXTCH_BELOW, {23, 2, {56, 64}}},
	{ 121, BAND_5, BW20, EXTCH_NONE, {30, 12, {100, 104, 108, 112, 116, 120, 124, \
					       128, 132, 136, 140, 144}}},
	{ 122, BAND_5, BW40, EXTCH_ABOVE, {30, 6, {100, 108, 116, 124, 132, 140}}},
	{ 123, BAND_5, BW40, EXTCH_BELOW, {30, 6, {104, 112, 120, 128, 136, 144}}},
	{ 124, BAND_5, BW20, EXTCH_NONE, {36, 4, {149, 153, 157, 161}}},
	{ 125, BAND_5, BW20, EXTCH_NONE, {36, 6, {149, 153, 157, 161, 165, 169}}},
	{ 126, BAND_5, BW40, EXTCH_ABOVE, {36, 2, {149, 157}}},
	{ 127, BAND_5, BW40, EXTCH_BELOW, {36, 2, {153, 161}}},
	{ 128, BAND_5, BW80, EXTCH_AUTO, {23, 6, {36, 52, 100, 116, 132, 149}}},
	{ 129, BAND_5, BW160, EXTCH_AUTO, {23, 2, {36, 100}}},
	{ 130, BAND_5, BW8080, EXTCH_AUTO, {23, 6, {36, 52, 100, 116, 132, 149}}},
};

#define wifi_opclass_global_size	\
	sizeof(wifi_opclass_global)/sizeof(wifi_opclass_global[0])

int wifi_get_opclass_entry(uint32_t opclass, struct wifi_opclass_entry *e)
{
	struct wifi_opclass_entry *tab;
	struct wifi_opclass_entry *ptr;
	int tabsize;
	int i;

	tab = (struct wifi_opclass_entry *)wifi_opclass_global;
	tabsize = wifi_opclass_global_size;

	for (i = 0; i < tabsize; i++) {
		ptr = tab + i;
		if (ptr->opclass == opclass) {
			memcpy(e, ptr, sizeof(struct wifi_opclass_entry));
			return 0;
		}
	}

	return -1;
}
